Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 55856 | Accepted: 16191 |
Description
Input
Output
Sample Input
1 5 1 4 2 6 8 10 3 4 7 10
Sample Output
4
Source
Alberta Collegiate Programming Contest 2003.10.18
参照 线段树完全版
/**
题意:在墙上贴海报,海报可以互相覆盖,问最后可以看见几张海报
离散化简单的来说就是只取我们需要的值来用,比如说区间[1000,2000],[1990,2012] 我们用不到[-∞,999][1001,1989][1991,1999][2001,2011][2013,+∞]这些值,所以我只需要1000,1990,2000,2012就够了,将其分别映射到0,1,2,3,在于复杂度就大大的降下来了
所以离散化要保存所有需要用到的值,排序后,分别映射到1~n,这样复杂度就会小很多很多
给出下面两个简单的例子应该能体现普通离散化的缺陷:
1-10 1-4 5-10
1-10 1-4 6-10
为了解决这种缺陷,我们可以在排序后的数组上加些处理,比如说[1,2,6,10]
如果相邻数字间距大于1的话,在其中加上任意一个数字,比如加成[1,2,3,6,7,10],然后再做线段树就好了.
线段树功能:update:成段替换 query:简单hash
**/
ACcode:
#include <cstdio> #include <cstring> #include <algorithm> #define maxn 12345 #define ll long long #define m ((l+r)>>1) #define tmp (st<<1) #define lson l,m,tmp #define rson m+1,r,tmp|1 using namespace std; int tree[maxn<<2]; bool hash[maxn]; int li[maxn],ri[maxn]; int col[maxn<<4]; int ans; void push_down(int st){ if(col[st]!=-1){ col[tmp]=col[tmp|1]=col[st]; col[st]=-1; } } void update(int L,int R,int c,int l,int r,int st) { if (L<=l &&r<=R) { col[st]=c; return; } push_down(st); if (L<=m) update(L,R,c, lson); if (m<R) update(L,R,c,rson); } void query(int l,int r,int st) { if (col[st]!=-1){ if (!hash[col[st]])ans++; hash[col[st] ]=true; return ; } if (l==r) return; query(lson); query(rson); } int Bin(int key,int n,int tree[]) { int l = 0 , r = n - 1; while (l<=r) { if (tree[m] == key) return m; if (tree[m] < key) l = m + 1; else r = m - 1; } return -1; } int main() { int T , n; scanf("%d",&T); while (T --) { scanf("%d",&n); int nn = 0; for (int i = 0 ; i < n ; i ++) { scanf("%d%d",&li[i] , &ri[i]); tree[nn++] = li[i]; tree[nn++] = ri[i]; } sort(tree,tree+nn); int pos=1; for (int i=1;i<nn;i++) if (tree[i] != tree[i-1]) tree[pos++]=tree[i];//去重 for (int i=pos-1; i>0;i --) if (tree[i]!= tree[i-1]+1) tree[pos++] =tree[i-1] + 1;//加点防止错误 sort(tree,tree+pos); memset(col , -1 , sizeof(col)); for (int i = 0 ; i < n ; i ++) {//二分找海报端点然后更新贴海报的前后顺序 int l=Bin(li[i],pos,tree); int r=Bin(ri[i],pos,tree); update(l,r,i,0,pos,1); } ans=0; memset(hash,false,sizeof(hash)); query(0, pos,1); printf("%d\n",ans); } return 0; }